var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { fetchDelete, fetchGet, fetchPost } from "../../../utils/fetch";
export class TagResource {
    constructor(client) {
        this.client = client;
    }
    addTag(name) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield fetchPost(`${this.client.apiBaseUrl}/tag`, JSON.stringify({ name }), {
                "Authorization": `Bearer ${this.client.authToken}`,
                "Content-Type": "application/json"
            })
                .then((res) => {
                return Promise.resolve(res.data);
            })
                .catch((err) => {
                var _a, _b, _c;
                return Promise.reject((_c = (_b = (_a = err.response) === null || _a === void 0 ? void 0 : _a.data) === null || _b === void 0 ? void 0 : _b.error) !== null && _c !== void 0 ? _c : err);
            });
        });
    }
    deleteTag(id) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield fetchDelete(`${this.client.apiBaseUrl}/tag`, { tag_id: id }, {
                "Authorization": `Bearer ${this.client.authToken}`,
                "Content-Type": "application/json"
            })
                .then((res) => {
                return Promise.resolve(res.data);
            })
                .catch((err) => {
                var _a, _b, _c;
                return Promise.reject((_c = (_b = (_a = err.response) === null || _a === void 0 ? void 0 : _a.data) === null || _b === void 0 ? void 0 : _b.error) !== null && _c !== void 0 ? _c : err);
            });
        });
    }
    getTags() {
        return __awaiter(this, void 0, void 0, function* () {
            return yield fetchGet(`${this.client.apiBaseUrl}/tags`)
                .then((res) => {
                return Promise.resolve(res.data);
            })
                .catch((err) => {
                var _a, _b, _c;
                return Promise.reject((_c = (_b = (_a = err.response) === null || _a === void 0 ? void 0 : _a.data) === null || _b === void 0 ? void 0 : _b.error) !== null && _c !== void 0 ? _c : err);
            });
        });
    }
}
//# sourceMappingURL=tag.js.map