import { TorrentResponse, TorrentListing } from "torrust-index-types-lib";
import { Rest } from "../rest";
import { IRestResource } from "../restResource";
type GetTorrentsParams = {
    pageSize: number;
    page: number;
    sorting: string;
    categories?: Array<string>;
    tags?: Array<string>;
    searchQuery?: string;
};
type GetTorrentsResponseData = {
    total: number;
    results: Array<TorrentListing>;
};
type DeleteTorrentResponseData = {
    data: {
        torrent_id: number;
        info_hash: string;
    };
};
type UpdateTorrentParams = {
    title?: string;
    description?: string;
    tags?: number[];
};
type UploadTorrentParams = {
    title: string;
    category: string;
    description: string;
    tags: Array<number>;
    file: any;
};
type NewTorrentResponseData = {
    torrent_id: number;
    canonical_info_hash: string;
    info_hash: string;
};
export declare class TorrentResource implements IRestResource {
    client: Rest;
    constructor(client: Rest);
    headers(): HeadersInit | undefined;
    getTorrentInfo(infoHash: string): Promise<TorrentResponse>;
    getTorrents(params: GetTorrentsParams): Promise<GetTorrentsResponseData>;
    deleteTorrent(infoHash: string): Promise<DeleteTorrentResponseData>;
    updateTorrent(infoHash: string, params: UpdateTorrentParams): Promise<TorrentResponse>;
    uploadTorrent(params: UploadTorrentParams): Promise<NewTorrentResponseData>;
    downloadTorrent(infoHash: string): Promise<Blob>;
    proxiedImage(url: string): Promise<Blob>;
}
export {};
