import { Rest } from "../rest";
import { IRestResource } from "../restResource";
import { TokenResponse, UserProfile } from "torrust-index-types-lib";
type LoginUserParams = {
    login: string;
    password: string;
};
type RegisterUserParams = {
    username: string;
    email: string;
    password: string;
    confirm_password: string;
};
type ChangePasswordParams = {
    current_password: string;
    password: string;
    confirm_password: string;
};
type GetUserProfilesParams = {
    pageSize: number;
    page: number;
    sorting?: string;
    filters?: Array<string>;
    searchQuery?: string;
};
type GetUserProfilesResponseData = {
    total: number;
    results: Array<UserProfile>;
};
export declare class UserResource implements IRestResource {
    client: Rest;
    constructor(client: Rest);
    loginUser(params: LoginUserParams): Promise<TokenResponse>;
    registerUser(params: RegisterUserParams): Promise<boolean>;
    renewToken(): Promise<TokenResponse>;
    changePassword(params: ChangePasswordParams, username: string): Promise<boolean>;
    getUserProfiles(params: GetUserProfilesParams): Promise<GetUserProfilesResponseData>;
}
export {};
