var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
export function request(path, config) {
    return __awaiter(this, void 0, void 0, function* () {
        var _a;
        const request = new Request(path, config);
        const response = yield fetch(request);
        if (!response.ok) {
            const res = yield response.json();
            throw new Error((_a = res === null || res === void 0 ? void 0 : res.error) !== null && _a !== void 0 ? _a : response.statusText);
        }
        return response;
    });
}
export function fetchGet(path, headers) {
    return __awaiter(this, void 0, void 0, function* () {
        const init = { method: "get", headers: Object.assign({ "Content-Type": "application/json" }, headers) };
        const response = yield request(path, init);
        return response.json().catch(() => ({}));
    });
}
export function fetchGetBlob(path, headers) {
    return __awaiter(this, void 0, void 0, function* () {
        const init = { method: "get", headers: Object.assign({}, headers) };
        const response = yield request(path, init);
        return response.blob().catch(() => (new Blob));
    });
}
export function fetchPost(path, body, headers) {
    return __awaiter(this, void 0, void 0, function* () {
        const init = { method: "post", headers: Object.assign({}, headers), body };
        const response = yield request(path, init);
        return response.json().catch(() => ({}));
    });
}
export function fetchPut(path, body, headers) {
    return __awaiter(this, void 0, void 0, function* () {
        const init = { method: "put", headers: Object.assign({ "Content-Type": "application/json" }, headers), body: JSON.stringify(body) };
        const response = yield request(path, init);
        return response.json().catch(() => ({}));
    });
}
export function fetchDelete(path, body, headers) {
    return __awaiter(this, void 0, void 0, function* () {
        const init = { method: "delete", headers: Object.assign({ "Content-Type": "application/json" }, headers), body: JSON.stringify(body) };
        const response = yield request(path, init);
        return response.json().catch(() => ({}));
    });
}
//# sourceMappingURL=fetch.js.map